DEFAULT_ORIGINATOR = 'avataobot'


class MessageSender:
    def __init__(self, uplink):
        self.uplink = uplink

    def send(self, message, originator=DEFAULT_ORIGINATOR, buttons=None):
        message = {
            'key': 'message.send',
            'message': message
        }
        if originator:
            message['originator'] = originator
        if buttons:
            message['buttons'] = buttons
        self.uplink.send_message(message)

    def queue_messages(self, messages, originator=DEFAULT_ORIGINATOR, buttons=None):
        message_queue = {
            'key': 'message.queue',
            'messages': []
        }
        for message in messages:
            next_message = {'message': message}
            if originator:
                next_message['originator'] = originator
            message_queue['messages'].append(next_message)
        if buttons and message_queue['messages']:
            message_queue['messages'][-1]['buttons'] = buttons
        self.uplink.send_message(message_queue)
